// Copyright © 2010 DELAYEN Julien, DELAYEN Florent

/*
    This file is part of Schedio.

    Schedio is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Schedio is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Schedio.  If not, see <http://www.gnu.org/licenses/>.
*/
#include "file.h"
#include <gtk/gtk.h>

int set_param(char* file, char* name, int nb, GSList* gslist)
{
    int i=0;
    FILE* f = NULL;
    f=fopen(file,"a+");
    fprintf(f,"[%s]\n",name);
    while(i<nb)
    {
        fprintf(f,"%s\n",g_slist_nth_data (gslist, i));
        i++;
    }
    fclose(f);
    return 0;
}

int get_param(char* file,int num,char *name,char **param)
{
    int i=0,j=0,k=0,nb_param=0;
    char test[1000];
    FILE* f=NULL;
    int ret_code = -1;

    f=fopen(file,"r");
    fgets(test,1000,f);

    while(k!=num && !feof(f))
    {
        fgets(test,1000,f);
        if(test[0]=='[')k+=1;
    }

    if(k==num)
    {
        for(i=0;i<strlen(test);i++)
        {
            test[i]=test[i+1];
            if(test[i]==']')test[i]='\0';
        }
        name = realloc(name,strlen(test)*sizeof(char));
        sprintf(name,"%s",test);
        fprintf(stderr,"name : %s\n",name);
        fgets(test,1000,f);
    }

    while(test[0]!='[' && !feof(f))
    {
        if(test[0]!='#')
        {
            for(i=0;i<strlen(test);i++)
            {
                if(test[i]=='\n')test[i]='\0';
            }
            ret_code = 0;
            nb_param+=1;
            param = realloc(param,nb_param*sizeof(char*));
            param[nb_param-1]=malloc(strlen(test)*sizeof(char));
            sprintf(param[nb_param-1],"%s",test);
            fprintf(stderr,"debugging value : %s\n",param[nb_param-1]);
            fgets(test,1000,f);
        }
    }

    fclose(f);
    return nb_param;
}
